searchData={"items":[{"type":"module","title":"AshNeo4j.Cypher","doc":"Ash Neo4j cypher functions","ref":"AshNeo4j.Cypher.html"},{"type":"function","title":"AshNeo4j.Cypher.expression/4","doc":"Converts a node variable, label and optional properties to cypher expression","ref":"AshNeo4j.Cypher.html#expression/4"},{"type":"function","title":"Examples - AshNeo4j.Cypher.expression/4","doc":"```\niex> AshNeo4j.Cypher.expression(:s, \"name\", \"in\", \"[Bill Nighy]\")\n\"s.name in [Bill Nighy]\"\niex> AshNeo4j.Cypher.expression(:s, \"name\", \"in\", \"[]\")\n\"s.name IS NOT NULL\"\n```","ref":"AshNeo4j.Cypher.html#expression/4-examples"},{"type":"function","title":"AshNeo4j.Cypher.node/3","doc":"Converts a node variable, label and optional properties to cypher node.","ref":"AshNeo4j.Cypher.html#node/3"},{"type":"function","title":"Examples - AshNeo4j.Cypher.node/3","doc":"```\niex> AshNeo4j.Cypher.node(:s, :Actor)\n\"(s:Actor)\"\niex> AshNeo4j.Cypher.node(:s, :Actor, %{name: \"Bill Nighy\"})\n\"(s:Actor {name: 'Bill Nighy'})\"\n```","ref":"AshNeo4j.Cypher.html#node/3-examples"},{"type":"function","title":"AshNeo4j.Cypher.properties/1","doc":"Converts a map to a cypher properties string.\nThe map is converted to a string in the format `{key1: value1, key2: value2}`.\nThis is used to create nodes in Neo4j.","ref":"AshNeo4j.Cypher.html#properties/1"},{"type":"function","title":"Examples - AshNeo4j.Cypher.properties/1","doc":"```\niex> AshNeo4j.Cypher.properties(%{name: \"Bill Nighy\", born: 1949, bafta_winner: true})\n\"{name: 'Bill Nighy', born: 1949, bafta_winner: true}\"\n```","ref":"AshNeo4j.Cypher.html#properties/1-examples"},{"type":"function","title":"AshNeo4j.Cypher.relationship/1","doc":"Converts a node_relationship tuple to cypher clause, ignoring the label","ref":"AshNeo4j.Cypher.html#relationship/1"},{"type":"function","title":"Examples - AshNeo4j.Cypher.relationship/1","doc":"```\niex> AshNeo4j.Cypher.relationship({:movies, :ACTED_IN, :outgoing})\n\"-[r:ACTED_IN]->\"\niex> AshNeo4j.Cypher.relationship(nil)\n\"-[r]-\"\n```","ref":"AshNeo4j.Cypher.html#relationship/1-examples"},{"type":"function","title":"AshNeo4j.Cypher.relationship/3","doc":"Converts a relationship variable, label and optional direction to cypher relationship.","ref":"AshNeo4j.Cypher.html#relationship/3"},{"type":"function","title":"Examples - AshNeo4j.Cypher.relationship/3","doc":"```\niex> AshNeo4j.Cypher.relationship(:r, :ACTED_IN, :outgoing)\n\"-[r:ACTED_IN]->\"\niex> AshNeo4j.Cypher.relationship(:r, :ACTED_IN, :incoming)\n\"<-[r:ACTED_IN]-\"\niex> AshNeo4j.Cypher.relationship(:r, :KNOWS)\n\"-[r:KNOWS]-\"\n```","ref":"AshNeo4j.Cypher.html#relationship/3-examples"},{"type":"function","title":"AshNeo4j.Cypher.run/1","doc":"Runs some cypher","ref":"AshNeo4j.Cypher.html#run/1"},{"type":"function","title":"Examples - AshNeo4j.Cypher.run/1","doc":"```\niex> cypher = \"CREATE (n:Actor {name: 'Bill Nighy', born: 1949, bafta_winner: true}) RETURN n\"\niex> {result, _} = AshNeo4j.Cypher.run(cypher)\niex> result\n:ok\n```","ref":"AshNeo4j.Cypher.html#run/1-examples"},{"type":"module","title":"AshNeo4j.DataLayer","doc":"Ash DataLayer for Neo4j","ref":"AshNeo4j.DataLayer.html"},{"type":"function","title":"AshNeo4j.DataLayer.filter_matches/3","doc":"","ref":"AshNeo4j.DataLayer.html#filter_matches/3"},{"type":"macro","title":"AshNeo4j.DataLayer.neo4j/1","doc":"","ref":"AshNeo4j.DataLayer.html#neo4j/1"},{"type":"module","title":"AshNeo4j.DataLayer.BoltxHelper","doc":"AshNeo4j DataLayer BoltxHelper functions","ref":"AshNeo4j.DataLayer.BoltxHelper.html"},{"type":"function","title":"AshNeo4j.DataLayer.BoltxHelper.from_elixir_duration/1","doc":"Converts an Elixir Duration to a Boltx.Types.Duration","ref":"AshNeo4j.DataLayer.BoltxHelper.html#from_elixir_duration/1"},{"type":"function","title":"Examples - AshNeo4j.DataLayer.BoltxHelper.from_elixir_duration/1","doc":"```\niex> AshNeo4j.DataLayer.BoltxHelper.from_elixir_duration(Duration.new!(%{year: 1, month: 2, week: 3, day: 4, hour: 5, minute: 6, second: 7, microsecond: {8, 6}}))\n%Boltx.Types.Duration{years: 1, months: 2, weeks: 0, days: 25, hours: 5, minutes: 6, seconds: 7, nanoseconds: 8000}\n\niex> AshNeo4j.DataLayer.BoltxHelper.from_elixir_duration(Duration.new!(%{month: 1}))\n%Boltx.Types.Duration{years: 0, months: 1, weeks: 0, days: 0, hours: 0, minutes: 0, seconds: 0, nanoseconds: 0}\n```","ref":"AshNeo4j.DataLayer.BoltxHelper.html#from_elixir_duration/1-examples"},{"type":"function","title":"AshNeo4j.DataLayer.BoltxHelper.to_elixir_duration/1","doc":"Converts a Boltx.Types.Duration to an Elixir Duration","ref":"AshNeo4j.DataLayer.BoltxHelper.html#to_elixir_duration/1"},{"type":"function","title":"Examples - AshNeo4j.DataLayer.BoltxHelper.to_elixir_duration/1","doc":"```\niex> AshNeo4j.DataLayer.BoltxHelper.to_elixir_duration(Boltx.Types.Duration.create(14, 25, 18367, 8000))\n%Duration{year: 1, month: 2, week: 3, day: 4, hour: 5, minute: 6, second: 7, microsecond: {8, 6}}\n\niex> AshNeo4j.DataLayer.BoltxHelper.to_elixir_duration(Boltx.Types.Duration.create(1, 0, 0, 0))\n%Duration{month: 1}\n```","ref":"AshNeo4j.DataLayer.BoltxHelper.html#to_elixir_duration/1-examples"},{"type":"module","title":"AshNeo4j.DataLayer.Cast","doc":"Casting for AshNeo4j.DataLayer","ref":"AshNeo4j.DataLayer.Cast.html"},{"type":"function","title":"AshNeo4j.DataLayer.Cast.cast/3","doc":"Casts an Ash.Resource.Attribute","ref":"AshNeo4j.DataLayer.Cast.html#cast/3"},{"type":"module","title":"AshNeo4j.DataLayer.Info","doc":"Introspection helpers for AshNeo4j.DataLayer","ref":"AshNeo4j.DataLayer.Info.html"},{"type":"function","title":"AshNeo4j.DataLayer.Info.convert_to_property_name/2","doc":"Converts an attribute name to a node property name string, translating if necessary\nThe attribute name can be an Ash.Query.Ref or atom","ref":"AshNeo4j.DataLayer.Info.html#convert_to_property_name/2"},{"type":"function","title":"AshNeo4j.DataLayer.Info.label/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#label/1"},{"type":"function","title":"AshNeo4j.DataLayer.Info.node_relationship/2","doc":"","ref":"AshNeo4j.DataLayer.Info.html#node_relationship/2"},{"type":"function","title":"AshNeo4j.DataLayer.Info.relate/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#relate/1"},{"type":"function","title":"AshNeo4j.DataLayer.Info.relationship/3","doc":"Returns any matching Ash.Resource.Info relationship given relationship and destination node labels","ref":"AshNeo4j.DataLayer.Info.html#relationship/3"},{"type":"function","title":"AshNeo4j.DataLayer.Info.skip/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#skip/1"},{"type":"function","title":"AshNeo4j.DataLayer.Info.source_node_property_name/3","doc":"Returns the source node property name given the source resource and destination attribute name, i.e. post_id returns uuid","ref":"AshNeo4j.DataLayer.Info.html#source_node_property_name/3"},{"type":"function","title":"AshNeo4j.DataLayer.Info.translate/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#translate/1"},{"type":"function","title":"AshNeo4j.DataLayer.Info.translation/1","doc":"","ref":"AshNeo4j.DataLayer.Info.html#translation/1"},{"type":"module","title":"AshNeo4j.Neo4jHelper","doc":"AshNeo4j DataLayer Neo4j Helper","ref":"AshNeo4j.Neo4jHelper.html"},{"type":"function","title":"AshNeo4j.Neo4jHelper.create_node/2","doc":"Creates a neo4j node with label and properties","ref":"AshNeo4j.Neo4jHelper.html#create_node/2"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.create_node/2","doc":"```\niex> {result, _} = AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\"})\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#create_node/2-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.delete_all/0","doc":"Delete all neo4j nodes and relationships","ref":"AshNeo4j.Neo4jHelper.html#delete_all/0"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.delete_all/0","doc":"```\niex> {result, _} = AshNeo4j.Neo4jHelper.delete_all()\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#delete_all/0-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.delete_nodes/2","doc":"Delete neo4j nodes","ref":"AshNeo4j.Neo4jHelper.html#delete_nodes/2"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.delete_nodes/2","doc":"```\niex> {result, _} = AshNeo4j.Neo4jHelper.delete_nodes(:Actor)\niex> result\n:ok\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\"})\niex> {result, _} = AshNeo4j.Neo4jHelper.delete_nodes(:Actor, %{name: \"Bill Nighy\"})\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#delete_nodes/2-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.merge_node/2","doc":"Merges a neo4j node with label and properties","ref":"AshNeo4j.Neo4jHelper.html#merge_node/2"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.merge_node/2","doc":"```\niex> {result, _} = AshNeo4j.Neo4jHelper.merge_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#merge_node/2-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.nodes_relate_how?/6","doc":"Tests if two nodes are related with a relationship type","ref":"AshNeo4j.Neo4jHelper.html#nodes_relate_how?/6"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.nodes_relate_how?/6","doc":"```\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> AshNeo4j.Neo4jHelper.create_node(:Movie, %{title: \"Love Actually\"})\niex> AshNeo4j.Neo4jHelper.relate_nodes(:Actor, %{name: \"Bill Nighy\"}, :Movie, %{title: \"Love Actually\"}, :ACTED_IN, :outgoing)\niex> AshNeo4j.Neo4jHelper.nodes_relate_how?(:Actor, %{name: \"Bill Nighy\"}, :Movie, %{title: \"Love Actually\"}, :ACTED_IN, :outgoing)\ntrue\n```","ref":"AshNeo4j.Neo4jHelper.html#nodes_relate_how?/6-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.read_limited/3","doc":"Reads limited nodes from Neo4j, given label, limit and optionally properties","ref":"AshNeo4j.Neo4jHelper.html#read_limited/3"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.read_limited/3","doc":"```\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> {:ok, %{records: records}} = AshNeo4j.Neo4jHelper.read_limited(:Actor, 1)\niex> length(records)\n1\n```","ref":"AshNeo4j.Neo4jHelper.html#read_limited/3-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.read_nodes/2","doc":"Reads nodes from Neo4j, given label, and optionally properties","ref":"AshNeo4j.Neo4jHelper.html#read_nodes/2"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.read_nodes/2","doc":"```\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> {:ok, %{records: records}} = AshNeo4j.Neo4jHelper.read_nodes(:Actor, %{name: \"Bill Nighy\"})\niex> length(records)\n1\n```","ref":"AshNeo4j.Neo4jHelper.html#read_nodes/2-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.relate_nodes/6","doc":"Relates two nodes with a relationship type, merging relationship","ref":"AshNeo4j.Neo4jHelper.html#relate_nodes/6"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.relate_nodes/6","doc":"```\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\", born: 1949})\niex> AshNeo4j.Neo4jHelper.create_node(:Movie, %{title: \"Love Actually\"})\niex> {result, _} = AshNeo4j.Neo4jHelper.relate_nodes(:Actor, %{name: \"Bill Nighy\"}, :Movie, %{title: \"Love Actually\"}, :ACTED_IN, :outgoing)\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#relate_nodes/6-examples"},{"type":"function","title":"AshNeo4j.Neo4jHelper.update_node/3","doc":"Updates neo4j node properties","ref":"AshNeo4j.Neo4jHelper.html#update_node/3"},{"type":"function","title":"Examples - AshNeo4j.Neo4jHelper.update_node/3","doc":"```\niex> AshNeo4j.Neo4jHelper.create_node(:Actor, %{name: \"Bill Nighy\"})\niex> {result, _} = AshNeo4j.Neo4jHelper.update_node(:Actor, %{name: \"Bill Nighy\"}, %{born: 1949})\niex> result\n:ok\n```","ref":"AshNeo4j.Neo4jHelper.html#update_node/3-examples"},{"type":"module","title":"AshNeo4j.QueryHelper","doc":"AshNeo4j DataLayer QueryHelper","ref":"AshNeo4j.QueryHelper.html"},{"type":"function","title":"AshNeo4j.QueryHelper.query_nodes/1","doc":"Queries nodes, using Ash.Query","ref":"AshNeo4j.QueryHelper.html#query_nodes/1"},{"type":"module","title":"AshNeo4j.Verifiers.VerifyIdTranslated","doc":"Verifies that id attribute is translated","ref":"AshNeo4j.Verifiers.VerifyIdTranslated.html"},{"type":"module","title":"AshNeo4j.Verifiers.VerifyLabelCamelCase","doc":"Verifies that the label is camelcase","ref":"AshNeo4j.Verifiers.VerifyLabelCamelCase.html"},{"type":"module","title":"AshNeo4j.Verifiers.VerifyProperties","doc":"Verifies that Neo4j properties follow conventions","ref":"AshNeo4j.Verifiers.VerifyProperties.html"},{"type":"module","title":"AshNeo4j.Verifiers.VerifyRelate","doc":"Verifies that a relate relates to a relationship, and that the edge label meets Neo4j conventions","ref":"AshNeo4j.Verifiers.VerifyRelate.html"},{"type":"extras","title":"Guide","doc":"# AshNeo4j\n\n[![Module Version](https://img.shields.io/hexpm/v/ash_neo4j)](https://hex.pm/packages/ash_neo4j)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen)](https://hexdocs.pm/ash_neo4j/)\n[![License](https://img.shields.io/hexpm/l/ash_neo4j)](https://github.com/diffo-dev/ash_neo4j/blob/master/LICENSE.md)\n\nAsh DataLayer for Neo4j, configurable using a simple DSL","ref":"readme.html"},{"type":"extras","title":"Installation - Guide","doc":"Add to the deps:\n\n```elixir\ndef deps do\n  [\n    {:ash_neo4j, \"~> 0.1.5\"},\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Guide","doc":"Configure `AshNeo4j.DataLayer` as `data_layer:` within `use Ash.Resource` options:\n\n```elixir\n  use Ash.Resource,\n    data_layer: AshNeo4j.DataLayer\n```","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - Guide","doc":"Each Ash.Resource requires configuration of its AshNeo4j.DataLayer. An example Comment resource is given below, it can belong to a Post resource.\n\n```elixir\ndefmodule Comment.Resource do\n  use Ash.Resource,\n    data_layer: AshNeo4j.DataLayer\n\n  neo4j do\n    label :Comment\n    relate [{:post, :BELONGS_TO, :outgoing}]\n    translate id: :uuid\n  end\n\n  actions do\n    default_accept(:*)\n    defaults([:create, :read, :update, :destroy])\n  end\n\n  attributes do\n    uuid_primary_key(:id)\n    attribute(:title, :string, public?: true)\n  end\n\n  relationships do\n    belongs_to(:post, Post, public?: true)\n  end\nend\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Label - Guide","doc":"The DSL may be used to label the Ash Resource's underlying graph node. If omitted the Ash Resource's short module name will be used.\n\n```elixir\n  neo4j do\n    label :Comment\n  end\n```","ref":"readme.html#label"},{"type":"extras","title":"Relate - Guide","doc":"The DSL is used to direct any node relationships.\n```elixir\n  neo4j do\n    relate [{:post, :BELONGS_TO, :outgoing}]\n  end\n```","ref":"readme.html#relate"},{"type":"extras","title":"Translate - Guide","doc":"The DSL may be used to translate the Ash Resource's attributes to node properties.\n```elixir\n  neo4j do\n    translate id: :uuid\n  end\n```","ref":"readme.html#translate"},{"type":"extras","title":"Skip - Guide","doc":"The DSL may be used to skip storing attributes as node properties. This is typically used for foreign keys, which not required with relate.\n```elixir\n  neo4j do\n    skip [:other_id]\n  end\n```","ref":"readme.html#skip"},{"type":"extras","title":"Verifiers - Guide","doc":"The DSL is verified against misconfiguration and violation of accepted neo4j conventions providing compile time errors:\n\n* label: neo4j label must be CamelCase\n* neo4j: neo4j property names should start with a letter and may contain numbers and underscores\n* relate: relationship_name must match the name of a relationship\n* relate: edge label must be upper case and may have an underscore\n* translate: :id attribute must be translated","ref":"readme.html#verifiers"},{"type":"extras","title":"Installing Neo4j and Configuring Boltx - Guide","doc":"ash_neo4j uses [neo4j](https://github.com/neo4j/neo4j) which must be installed and running.\n\nYour Ash application needs to configure, start and supervise [boltx](https://github.com/sagastume/boltx), see [boltx documentation](https://hexdocs.pm/boltx/). Make sure to configure any required authorisation.\n\nI've used Neo4j community edition 4.4 (bolt 4.4) and to connect using boltx I needed to also set the environment variable ```BOLT_VERSIONS=4.4``` to steer [bolt protocol handshake] (https://neo4j.com/docs/bolt/current/bolt/handshake).","ref":"readme.html#installing-neo4j-and-configuring-boltx"},{"type":"extras","title":"Elixir, Ash and Neo4j Types - Guide","doc":"We've made some decisions around how Ash/Elixir types are used to persist attributes as Neo4j properties. Where possible we've used 'native' Neo4j types, where this is not possible we've simply quoted to strings. Ash Array support is limited by Neo4j to lists of simple types which must be homogenous.\n\n\n| Ash Type shortname  | Ash Type Module           | Elixir Type Module | Attribute Value Example                                | Neo4j Node Property Value Cypher Example               | Cypher Type    |\n|---------------------|---------------------------|--------------------|--------------------------------------------------------|--------------------------------------------------------|----------------|\n| :atom               | Ash.Type.Atom             | Atom               | :a                                                     | \":a\"                                                   | STRING         |\n| :binary             | Ash.Type.Binary           | BitString          | <<1, 2, 3>>                                            | \"\\u0001\\u0002\\u0003\"                                   | STRING         |\n| :boolean            | Ash.Type.Boolean          | Boolean            | true                                                   | true                                                   | BOOLEAN        |\n| :integer            | Ash.Type.Integer          | Integer            | 1                                                      | 1                                                      | INTEGER        |\n| :float              | Ash.Type.Float            | Float              | 1.23456789                                             | 1.23456789                                             | FLOAT          |\n| :string             | Ash.Type.String           | BitString          | \"hello\"                                                | \"hello\"                                                | STRING         |\n| :tuple              | Ash.Type.Tuple            | Tuple              | \\{:a, 1, false\\}                                         | \"\\{:a, 1, false\\}\"                                       | STRING         |\n| :keyword            | Ash.Type.Keyword          | Keyword            | [\\{:a, :atom\\}, \\{:s, \"string\"\\}]                          | [\"\\{:a, :atom}\\\",\"\\{:s, string\\}\"]                         | LIST           |\n| :map                | Ash.Type.Map              | Map                | %\\{c: false, a: \"a\", b: 1, n: nil\\}                      | \"%\\{c: false, a: \"a\", b: 1, n: nil\\}\"                    | STRING         |\n| :mapset             | Ash.Type.MapSet           | MapSet             | MapSet.new([1, false, :two])                           | \"MapSet.new([1, false, :two])\"                         | STRING         |\n| :struct             | Ash.Type.Struct           | Struct             | %MyApp.Struct{a: :a, s: \"Hello\"}                       | \"%MyApp.Struct\\{a: :a, s: \\\"Hello\\\"\\}\"                   | STRING         |\n| :uuid               | Ash.Type.UUID             | BitString          | \"0274972c-161c-4dc9-882f-6851704c2af9\"                 | \"0274972c-161c-4dc9-882f-6851704c2af9                  | STRING         |\n| :url_encoded_binary | Ash.Type.UrlEncodedBinary | BitString          | \"aHR0cHM6Ly93d3cuZGlmZm8uZGV2Lw\"                       | \"aHR0cHM6Ly93d3cuZGlmZm8uZGV2Lw                        | STRING         |\n| :decimal            | Ash.Type.Decimal          | Decimal            | Decimal.new(\"4.2\")                                     | \"Decimal.new(\\\"4.2\\\")\"                                 | STRING         |\n| :ci_string          | Ash.Type.CiString         | BitString          | \"HELLO\"                                                | \"HELLO\"                                                | STRING         |\n| :function           | Ash.Type.Function         | Function           | &AshNeo4j.Neo4jHelper.create_node/2                    | \"&AshNeo4j.Neo4jHelper.create_node/2\"                  | STRING         |\n| :module             | Ash.Type.Module           | Module             | AshNeo4j.DataLayer                                     | \":Elixir.AshNeo4j.DataLayer\"                           | STRING         |\n| :regex              | Ash.Type.Regex            | Regex              | ~r/foo/iu                                              | \"~r/foo/iu\"                                            | STRING         |\n| \\{:array, :atom\\}     | -                         | List               | [:a,:b,:c]                                             | [\":a\",\":b\",\":c\"]                                       | LIST           |\n| \\{:array, :boolean\\}  | -                         | List               | [true,true,false]                                      | [true,true,false]                                      | LIST           |\n| \\{:array, :integer\\}  | -                         | List               | [1,2,3]                                                | [1,2,3]                                                | LIST           |\n| \\{:array, :map\\}      | -                         | List               | [%MyApp.Struct\\{a: :a, s: \"Hello\"\\}]                     | [\"%MyApp.Struct\\{a: :a, s: \\\"Hello\\\"\\}\"]                 | LIST           |\n| \\{:array, :term\\}     | -                         | List               | [%MyApp.Struct\\{a: :a, s: \"Hello\"\\}]                     | [\"%MyApp.Struct\\{a: :a, s: \\\"Hello\\\"\\}\"]                 | LIST           |\n| :date               | Ash.Type.Date             | Date               | ~D[2025-02-25]                                         | 2025-05-11                                             | DATE           |\n| :datetime           | Ash.Type.DateTime         | DateTime           | ~U[2025-02-25 11:59:00Z]                               | 2025-05-11T07:45:41Z                                   | ZONED_DATETIME |\n| :utc_datetime_usec  | Ash.Type.UtcDateTimeUsec  | DateTime           | ~U[2025-02-25 11:59:00.123456Z]                        | 2025-05-11T07:45:41.429903Z                            | ZONED_DATETIME |\n| :naive_datetime     | Ash.Type.NaiveDateTime    | NaiveDateTime      | ~N[2025-05-11 07:45:41]                                | 2025-05-11T07:45:41                                    | LOCAL_DATETIME |\n| :time               | Ash.Type.Time             | Time               | ~T[07:45:41Z]                                          | 07:45:41                                               | TIME           |\n| :time_usec          | Ash.Type.TimeUsec         | Time               | ~T[07:45:41.429903Z]                                   | 07:45:41.429903                                        | TIME           |\n| :duration           | Ash.Type.Duration         | Duration           | %Duration{month: 2}                                    | PT2H                                                   | DURATION       |\n\nAsh :date, :datetime, :time and :naive_datetime are second precision, whereas :utc_datetime_usec and :time_usec are microsecond precision. Note that :time_usec requires ash ~> 3.5.10 (to be released).","ref":"readme.html#elixir-ash-and-neo4j-types"},{"type":"extras","title":"Elixir nil and Neo4j Null - Guide","doc":"Generally attributes with nil value are not persisted, rather than created with Null value. However values of nil within string quoted 'Elixir' types (keyword, tuple, map and struct) are persisted.","ref":"readme.html#elixir-nil-and-neo4j-null"},{"type":"extras","title":"Limitations and Future Work - Guide","doc":"Ash Neo4j is early stage, it is likely that the dsl will evolve and this may break back compatibility. Ash Neo4j is in 'build' phase with initial support for Ash create, update, read, destroy actions. Collaboration on ash_neo4j welcome via github, please use discussions and/or raise issues as you encounter them.","ref":"readme.html#limitations-and-future-work"},{"type":"extras","title":"Acknowledgements - Guide","doc":"Thanks to the [Ash Core](https://github.com/ash-project) for [ash](https://github.com/ash-project/ash) 🚀, including [ash_csv](https://github.com/vonagam/ash_jason) which was an exemplar.\n\nThanks to [Sagastume](https://github.com/sagastume) for [boltx](https://github.com/tiagodavi/ex4j) which AFAIK was based on [bolt_sips](https://github.com/florinpatrascu/bolt_sips) by [Florin Patrascu](https://github.com/florinpatrascu).\n\nThanks to the [Neo4j Core](https://github.com/neo4j) for [neo4j](https://github.com/neo4j/neo4j) and pioneering work on graph databases.","ref":"readme.html#acknowledgements"},{"type":"extras","title":"Links - Guide","doc":"[Diffo.dev](https://www.diffo.dev)\n[Neo4j Deployment Centre](https://neo4j.com/deployment-center/).","ref":"readme.html#links"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2025 Matthew Graham Beanland\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"DSL","title":"neo4j - dsl-ashneo4j-datalayer","doc":"","ref":"dsl-ashneo4j-datalayer.html#neo4j"},{"type":"DSL","title":"neo4j.label - dsl-ashneo4j-datalayer","doc":"Optional node label","ref":"dsl-ashneo4j-datalayer.html#neo4j-label"},{"type":"DSL","title":"neo4j.relate - dsl-ashneo4j-datalayer","doc":"Optional list of node relationships, as tuples of {relationship_name, edge_label, edge_direction}","ref":"dsl-ashneo4j-datalayer.html#neo4j-relate"},{"type":"DSL","title":"neo4j.skip - dsl-ashneo4j-datalayer","doc":"Optional list of attributes not to be stored directly as node properties","ref":"dsl-ashneo4j-datalayer.html#neo4j-skip"},{"type":"DSL","title":"neo4j.translate - dsl-ashneo4j-datalayer","doc":"Optional list of attribute to node property translations","ref":"dsl-ashneo4j-datalayer.html#neo4j-translate"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}